\documentclass[a4paper, 11pt, oneside]{scrartcl}
\usepackage{lpp}
\usepackage{verbatim}
\usepackage[section]{placeins}

\begin{document}

\mtitle{Project 2}

\sauthor{Rodrigo Barros Miguez}

\maff{Laboratory for Parallel Programming}{rodrigo.miguez@rwth-aachen.de}{}

\mabstract{In this project a numerical solver is parallelized using openMP directives. Also,
compiler flags are used to optimize the running times of the code.}

\section{Introduction}

Due to the increasing complexity of simulation cases of interest and the use of multicore
processors,
parallelization of codes via shared memory has become standard. One of the libraries for such
type of parallelization is the so called openMP standard, which can be used to spwan threads that
splits
the work of a simulation among themselves.
In this project, the solver used previously in project 1 is
optimized using different compiler flags and the code is parallelized using openMP.

\section{Implementation and Results}

The first part of the project consisted in finding which parts of the code where the ones taking
longer to be processed. Below a code structure is presented where we can see the the clock command
locations to get the running times of each section of the code:

\begin{verbatim}

void femSolver::solverControl(inputSettings* argSettings, triMesh* argMesh)
{
    cout << endl << "=================== SOLUTION =====================" << endl;

    mesh = argMesh;
    settings = argSettings;
    int ne = mesh->getNe();
    double start, end;

    for(int iec=0; iec<ne; iec++)
    {
        calculateJacobian(iec);
        calculateElementMatrices(iec);
    }
    start = omp_get_wtime();
    applyDrichletBC();
    accumulateMass();
    explicitSolver();
    end = omp_get_wtime();
    cout << "Total time: " << end -start << endl;

    return;
}

void femSolver::solverControl(inputSettings* argSettings, triMesh* argMesh)
{
    cout << endl << "=================== SOLUTION =====================" << endl;

    mesh = argMesh;
    settings = argSettings;
    int ne = mesh->getNe();
    double start, end;

    for(int iec=0; iec<ne; iec++)
    {
        calculateJacobian(iec);
        calculateElementMatrices(iec);
    }

    start = omp_get_wtime();
    applyDrichletBC();
    end = omp_get_wtime();
    cout << "Time applyDrichletBC: " << end - start << endl;

    start = omp_get_wtime();
    accumulateMass();
    end = omp_get_wtime();
    cout << "Time accumulateMass: " << end - start << endl;

    start = omp_get_wtime();
    explicitSolver();
    end = omp_get_wtime();
    cout << "Time explicitSolver: " << end - start << endl;

    return;
}

void femSolver::explicitSolver()
{
    int const nn = mesh->getNn();
    int const ne = mesh->getNe();
    int const nIter = settings->getNIter();
    int e, i;
    double const dT = settings->getDt();
    double TL[3], MTnewL[3];
    double * massG = mesh->getMassG();
    double * MTnew = mesh->getMTnew();
    double * T = mesh->getT();
    double massTmp, MTnewTmp;
    double MT;
    double Tnew;
    double partialL2error, globalL2error, initialL2error;
    double* M;          // pointer to element mass matrix
    double* F;          // pointer to element forcing vector
    double* K;          // pointer to element stiffness matrix
    triElement* elem;   // temporary pointer to hold current element
    triNode* pNode;     // temporary pointer to hold partition nodes
    double maxT, minT, Tcur;
    minT = std::numeric_limits<double>::max();
    maxT = std::numeric_limits<double>::min();

    double startL1, endL1, totalL1;
    double startL2, endL2, totalL2;
    double startL3, endL3, totalL3;

    for (int iter=0; iter<nIter; iter++)
    {
        // clear RHS MTnew

        startL1= omp_get_wtime();
        for(i=0; i<nn; i++){
            MTnew[i] = 0;
        }
        endL1= omp_get_wtime();
        totalL1 += endL1 - startL1;


        // Evaluate right hand side at element level
        startL2= omp_get_wtime();
        for(e=0; e<ne; e++)
        {
            elem = mesh->getElem(e);
            M = elem->getMptr();
            F = elem->getFptr();
            K = elem->getKptr();
            for(i=0; i<nen; i++)
            {
                TL[i] = T[elem->getConn(i)];
            }

            MTnewL[0] = M[0]*TL[0] + dT*(F[0]-(K[0]*TL[0]+K[1]*TL[1]+K[2]*TL[2]));
            MTnewL[1] = M[1]*TL[1] + dT*(F[1]-(K[3]*TL[0]+K[4]*TL[1]+K[5]*TL[2]));
            MTnewL[2] = M[2]*TL[2] + dT*(F[2]-(K[6]*TL[0]+K[7]*TL[1]+K[8]*TL[2]));


            // RHS is accumulated at local nodes
            MTnew[elem->getConn(0)] += MTnewL[0];
            MTnew[elem->getConn(1)] += MTnewL[1];
            MTnew[elem->getConn(2)] += MTnewL[2];
        }
        endL2 = omp_get_wtime();
        totalL2 += endL2 - startL2;

        // Evaluate the new temperature on each node on partition level
        partialL2error = 0.0;
        globalL2error = 0.0;
        startL3 = omp_get_wtime();
        for(int i=0; i<nn; i++)
        {
            pNode = mesh->getNode(i);
            if(pNode->getBCtype() != 1)
            {
                massTmp = massG[i];
                MT = MTnew[i];
                Tnew = MT/massTmp;
                partialL2error += pow(T[i]-Tnew,2);
                T[i] = Tnew;
            }
        }
        endL3 = omp_get_wtime();
        totalL3 += endL3 - startL3;

        globalL2error = sqrt(partialL2error/nn);

        if(iter==0)
        {
            initialL2error = globalL2error;
            //cout << "Iter" << '\t' << "Time" << '\t' << "L2 Error" << '\t' << endl;
        }

        globalL2error = globalL2error / initialL2error;

        if(iter%1000==0)
        {
            //cout << iter << '\t';
            //cout << fixed << setprecision(5) << iter*dT << '\t';
            //cout << scientific << setprecision(5) << globalL2error << endl;
        }
        if(globalL2error <= 1.0E-6)
        {
          cout << "Loop 1 (total time): " << totalL1 << endl;
          cout << "Loop 2 (total time): " << totalL2 << endl;
          cout << "Loop 3 (total time): " << totalL3 << endl;
            //cout << iter << '\t';
            //cout << fixed << setprecision(5) << iter*dT << '\t';
            //cout << scientific << setprecision(5) << globalL2error << endl;
            break;
        }
    }

    return;
}


\end{verbatim}

The timings of the functions are presented below in table 1. There we can see that the function
"explicitsolver()" takes the largest time during the simulation and the loop number 2 in that
function is the most demanding one. Therefore, we are going to focus on parallelizing this loop. It
is important to mention that these measurements were obtained with no additional compiler flags and
commenting out the "#BSUB -x" command under the run.j file.

	\begin{table}[h]
	\footnotesize
	\centering
	\begin{tabular}{c | c }
	\textbf{Code} & \textbf{Time} \\
  Total & 2.3329e+02 \\
  applyDrichletBC & 1.5440e-03 \\
  accumulateMass & 4.1509e-04 \\
  explicitSolver & 2.2429e+02 \\
  Loop 1 & 2.2349e+00 \\
  Loop 2 & 2.2339e+02 \\
  Loop 3 & 2.8032e+01 \\
		\end{tabular}
	\caption{Code timings.}
	\end{table}

Now, new compiler flags were tested for the code. In table 2 showed below we can see different
combination of compiler flags and their running times. After this analysis, the flags "-O3 -ip" were
choosen to perform the following simulation runs.

	\begin{table}[h]
	\footnotesize
	\centering
	\begin{tabular}{c | c }
	\textbf{Flags} & \textbf{Time (sec)} \\
  -fast & 121 \\
  -O3 & 65  \\
  -ip & 62 \\
  -ipo & 150 \\
  -fp-model fast=2 & 302 \\
  -axsse4.2,ssse3,sse2 & 62 \\
  -axsse4.2 & 62 \\
  -fp-model fast=1 & 142 \\
  -O3 -ip -axSSE4.2 & 149 \\
  -O3 -axSSE4.2 & 150 \\
  -O3 -axSSE4.2,SSSE3,SSE2 & 133 \\
  -fast -axSSE4.2,SSSE3,SSE2 & 62 \\
  -ip -axSSE4.2,SSSE3,SSE2 & 62 \\
  -fast -ip -axSSE4.2,SSSE3,SSE2 & 130 \\
  -fast -ip -O3 & 130 \\
  -fast -O3 & 156 \\
  -O3 -ip & 61 \\
  -fast -ip & 131 \\
		\end{tabular}
	\caption{Compiler flag timings.}
	\end{table}

Finally, the last part of the project was to parallelize the solver. Below is presented two
different ways it was parallelized using openMP: one implementation with reduction and another one
with atomic.

\begin{verbatim}

void femSolver::explicitSolver()
{
    int const nn = mesh->getNn();
    int const ne = mesh->getNe();
    int const nIter = settings->getNIter();
    int e, i;
    double const dT = settings->getDt();
    double TL[3], MTnewL[3];
    double * massG = mesh->getMassG();
    double * MTnew = mesh->getMTnew();
    double * T = mesh->getT();
    double massTmp, MTnewTmp;
    double MT;
    double Tnew;
    double partialL2error, globalL2error, initialL2error;
    double* M;          // pointer to element mass matrix
    double* F;          // pointer to element forcing vector
    double* K;          // pointer to element stiffness matrix
    triElement* elem;   // temporary pointer to hold current element
    triNode* pNode;     // temporary pointer to hold partition nodes
    double maxT, minT, Tcur;
    minT = std::numeric_limits<double>::max();
    maxT = std::numeric_limits<double>::min();

    for (int iter=0; iter<nIter; iter++)
    {
        // clear RHS MTnew

        for(i=0; i<nn; i++){
            MTnew[i] = 0;
        }

        // Evaluate right hand side at element level
        #pragma omp parallel private(elem, M, F, K, TL)
        {
        #pragma omp for reduction(+:MTnew[:nn])
        for(e=0; e<ne; e++)
        {
            elem = mesh->getElem(e);
            M = elem->getMptr();
            F = elem->getFptr();
            K = elem->getKptr();
            for(i=0; i<nen; i++)
            {
                TL[i] = T[elem->getConn(i)];
            }

            MTnewL[0] = M[0]*TL[0] + dT*(F[0]-(K[0]*TL[0]+K[1]*TL[1]+K[2]*TL[2]));
            MTnewL[1] = M[1]*TL[1] + dT*(F[1]-(K[3]*TL[0]+K[4]*TL[1]+K[5]*TL[2]));
            MTnewL[2] = M[2]*TL[2] + dT*(F[2]-(K[6]*TL[0]+K[7]*TL[1]+K[8]*TL[2]));


            // RHS is accumulated at local nodes
            MTnew[elem->getConn(0)] += MTnewL[0];
            MTnew[elem->getConn(1)] += MTnewL[1];
            MTnew[elem->getConn(2)] += MTnewL[2];
        }
        }

        // Evaluate the new temperature on each node on partition level
        partialL2error = 0.0;
        globalL2error = 0.0;
        for(int i=0; i<nn; i++)
        {
            pNode = mesh->getNode(i);
            if(pNode->getBCtype() != 1)
            {
                massTmp = massG[i];
                MT = MTnew[i];
                Tnew = MT/massTmp;
                partialL2error += pow(T[i]-Tnew,2);
                T[i] = Tnew;
            }
        }

        globalL2error = sqrt(partialL2error/nn);

        if(iter==0)
        {
            initialL2error = globalL2error;
            //cout << "Iter" << '\t' << "Time" << '\t' << "L2 Error" << '\t' << endl;
        }

        globalL2error = globalL2error / initialL2error;

        if(iter%1000==0)
        {
            //cout << iter << '\t';
            //cout << fixed << setprecision(5) << iter*dT << '\t';
            //cout << scientific << setprecision(5) << globalL2error << endl;
        }
        if(globalL2error <= 1.0E-6)
        {
            //cout << iter << '\t';
            //cout << fixed << setprecision(5) << iter*dT << '\t';
            //cout << scientific << setprecision(5) << globalL2error << endl;
            break;
        }
    }

    return;
}

void femSolver::explicitSolver()
{
    int const nn = mesh->getNn();
    int const ne = mesh->getNe();
    int const nIter = settings->getNIter();
    int e, i;
    double const dT = settings->getDt();
    double TL[3], MTnewL[3];
    double * massG = mesh->getMassG();
    double * MTnew = mesh->getMTnew();
    double * T = mesh->getT();
    double massTmp, MTnewTmp;
    double MT;
    double Tnew;
    double partialL2error, globalL2error, initialL2error;
    double* M;          // pointer to element mass matrix
    double* F;          // pointer to element forcing vector
    double* K;          // pointer to element stiffness matrix
    triElement* elem;   // temporary pointer to hold current element
    triNode* pNode;     // temporary pointer to hold partition nodes
    double maxT, minT, Tcur;
    minT = std::numeric_limits<double>::max();
    maxT = std::numeric_limits<double>::min();

    for (int iter=0; iter<nIter; iter++)
    {
        // clear RHS MTnew

        for(i=0; i<nn; i++){
            MTnew[i] = 0;
        }

        // Evaluate right hand side at element level
        #pragma omp parallel private(elem, M, F, K, TL, MTnewL)
        {
        #pragma omp for //reduction(+:MTnew[:nn])
        for(e=0; e<ne; e++)
        {
            elem = mesh->getElem(e);
            M = elem->getMptr();
            F = elem->getFptr();
            K = elem->getKptr();
            for(i=0; i<nen; i++)
            {
                TL[i] = T[elem->getConn(i)];
            }

            MTnewL[0] = M[0]*TL[0] + dT*(F[0]-(K[0]*TL[0]+K[1]*TL[1]+K[2]*TL[2]));
            MTnewL[1] = M[1]*TL[1] + dT*(F[1]-(K[3]*TL[0]+K[4]*TL[1]+K[5]*TL[2]));
            MTnewL[2] = M[2]*TL[2] + dT*(F[2]-(K[6]*TL[0]+K[7]*TL[1]+K[8]*TL[2]));


            // RHS is accumulated at local nodes
            #pragma omp atomic
              MTnew[elem->getConn(0)] += MTnewL[0];
            #pragma omp atomic
              MTnew[elem->getConn(1)] += MTnewL[1];
            #pragma omp atomic
              MTnew[elem->getConn(2)] += MTnewL[2];
        }
        }

        // Evaluate the new temperature on each node on partition level
        partialL2error = 0.0;
        globalL2error = 0.0;
        for(int i=0; i<nn; i++)
        {
            pNode = mesh->getNode(i);
            if(pNode->getBCtype() != 1)
            {
                massTmp = massG[i];
                MT = MTnew[i];
                Tnew = MT/massTmp;
                partialL2error += pow(T[i]-Tnew,2);
                T[i] = Tnew;
            }
        }

        globalL2error = sqrt(partialL2error/nn);

        if(iter==0)
        {
            initialL2error = globalL2error;
            //cout << "Iter" << '\t' << "Time" << '\t' << "L2 Error" << '\t' << endl;
        }

        globalL2error = globalL2error / initialL2error;

        if(iter%1000==0)
        {
            //cout << iter << '\t';
            //cout << fixed << setprecision(5) << iter*dT << '\t';
            //cout << scientific << setprecision(5) << globalL2error << endl;
        }
        if(globalL2error <= 1.0E-6)
        {
            //cout << iter << '\t';
            //cout << fixed << setprecision(5) << iter*dT << '\t';
            //cout << scientific << setprecision(5) << globalL2error << endl;
            break;
        }
    }

    return;
}

\end{verbatim}

The results for both implementations are showed below in Fig. 1 and 2. Here we can see that the
reduction implementation presented faster running times, while the atomic way was not so
successfull. This runs were performed using the compiler flags and the command "#BSUB -x" was
uncommented in the run.j file. Figure 3 shows the temperature distribution for the atomic case,
which is similar to the other two cases, the parallel case with reduction and the serial solver.

\begin{figure}[h]
\centering
\includegraphics[width=0.7\textwidth]{../plots/reduction_run.png}
\caption{Timings obtained using reduction.}

\centering
\includegraphics[width=0.7\textwidth]{../plots/atomic_run.png}
\caption{Timings obtained using atomic.}
\end{figure}

\begin{figure}[h]
\centering
\includegraphics[width=0.7\textwidth]{../plots/temp_distribution.png}
\caption{Temperature distribution over the domain.}
\end{figure}

It was also observed that changing the #BSUB -x command in the run.j file can drastically change the
running time of the simulation.

\section{Conclusion}

In this project a solver using the Galerkin FEM method to solve a diffusion heat problem was used to
analyse the optimization of the code by the use of compiler flags. It was seen that while some flags
combinations do not increase the speed of the solver, some others can greatly accelerate the running speeds.
For this specific case it was found that the combination of "-O3 -ip" was the most
beneficial one in terms of speed. In addition, one part of the code was parallelized using the
reduction and atomic commands under the openMP library. It was seen that the parallelization with
reduction substantially increased the speed of the simulation, while the atomic way was not so
successfull.

\end{document}
